Public Class Form1
    Inherits System.Windows.Forms.Form

    Private UPV As New UPx.Application                                      'instantiate the driver (Must be added to references first!)

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents CloseButton As System.Windows.Forms.Button
    Friend WithEvents StartButton As System.Windows.Forms.Button
    Friend WithEvents Label1 As System.Windows.Forms.Label
    Friend WithEvents NumericUpDown1 As System.Windows.Forms.NumericUpDown
    Friend WithEvents Label2 As System.Windows.Forms.Label
    Friend WithEvents TextBox1 As System.Windows.Forms.TextBox
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(Form1))
        Me.CloseButton = New System.Windows.Forms.Button
        Me.StartButton = New System.Windows.Forms.Button
        Me.Label1 = New System.Windows.Forms.Label
        Me.NumericUpDown1 = New System.Windows.Forms.NumericUpDown
        Me.Label2 = New System.Windows.Forms.Label
        Me.TextBox1 = New System.Windows.Forms.TextBox
        CType(Me.NumericUpDown1, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.SuspendLayout()
        '
        'CloseButton
        '
        Me.CloseButton.Location = New System.Drawing.Point(112, 104)
        Me.CloseButton.Name = "CloseButton"
        Me.CloseButton.TabIndex = 0
        Me.CloseButton.Text = "Close"
        '
        'StartButton
        '
        Me.StartButton.Location = New System.Drawing.Point(16, 104)
        Me.StartButton.Name = "StartButton"
        Me.StartButton.TabIndex = 1
        Me.StartButton.Text = "Start"
        '
        'Label1
        '
        Me.Label1.Location = New System.Drawing.Point(16, 16)
        Me.Label1.Name = "Label1"
        Me.Label1.Size = New System.Drawing.Size(120, 23)
        Me.Label1.TabIndex = 2
        Me.Label1.Text = "Number of averages"
        '
        'NumericUpDown1
        '
        Me.NumericUpDown1.Location = New System.Drawing.Point(136, 16)
        Me.NumericUpDown1.Minimum = New Decimal(New Integer() {1, 0, 0, 0})
        Me.NumericUpDown1.Name = "NumericUpDown1"
        Me.NumericUpDown1.Size = New System.Drawing.Size(48, 20)
        Me.NumericUpDown1.TabIndex = 3
        Me.NumericUpDown1.Value = New Decimal(New Integer() {1, 0, 0, 0})
        '
        'Label2
        '
        Me.Label2.Location = New System.Drawing.Point(16, 64)
        Me.Label2.Name = "Label2"
        Me.Label2.Size = New System.Drawing.Size(104, 23)
        Me.Label2.TabIndex = 4
        Me.Label2.Text = "Average No."
        Me.Label2.TextAlign = System.Drawing.ContentAlignment.MiddleLeft
        '
        'TextBox1
        '
        Me.TextBox1.Location = New System.Drawing.Point(136, 64)
        Me.TextBox1.Name = "TextBox1"
        Me.TextBox1.ReadOnly = True
        Me.TextBox1.Size = New System.Drawing.Size(48, 20)
        Me.TextBox1.TabIndex = 5
        Me.TextBox1.Text = ""
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(208, 133)
        Me.Controls.Add(Me.TextBox1)
        Me.Controls.Add(Me.Label2)
        Me.Controls.Add(Me.NumericUpDown1)
        Me.Controls.Add(Me.Label1)
        Me.Controls.Add(Me.StartButton)
        Me.Controls.Add(Me.CloseButton)
        Me.Icon = CType(resources.GetObject("$this.Icon"), System.Drawing.Icon)
        Me.Name = "Form1"
        Me.Text = "1/n Octave Averaging"
        CType(Me.NumericUpDown1, System.ComponentModel.ISupportInitialize).EndInit()
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim Result As Boolean = False
        Dim Counter As Integer = 0
        Dim Instring As String

        UPV.InitTCP("Localhost")                                            ' connect UPV
        UPV.Timeout = 60001
        Do                                                                  'Read error queue until "0; No Error" shows up
            UPV.Write("SYST:ERR?")
            Instring = UPV.Read
            If Instring.StartsWith("0") Then
                Debug.WriteLine(" succeeded")
                Result = True
            End If
            Counter += 1
        Loop Until Result Or Counter > 10000
        UPV.Write("*GTL")                                                   'Allow local control
    End Sub

    Private Sub UPVCommand(ByVal CommandString As String)                   'Sends a command string
        Dim ErrString As String

        UPV.Write(CommandString)                                            'Basic command for sending a SCPI command to the UPV
        UPV.Write("Syst:Err?")                                              'Query error queue
        ErrString = UPV.Read                                                'Read top entry of error queue
        If Not ErrString.StartsWith("0") Then                               'If an error exists, a message is displayed and the application is ended
            MessageBox.Show("UPV Error" & ControlChars.CrLf & ErrString, String.Empty, MessageBoxButtons.OK, MessageBoxIcon.Exclamation, MessageBoxDefaultButton.Button1, MessageBoxOptions.DefaultDesktopOnly)
            Me.Close()
        End If
        Debug.WriteLine("UPV Command = " & CommandString & "   Err = " & ErrString)
    End Sub

    Private Function UPVQuery(ByVal QueryString As String) As String        'Sends a query string and returns the answer string
        Dim AnswerString As String
        Dim ErrString As String

        UPV.Write(QueryString)
        AnswerString = UPV.Read
        UPV.Write("Syst:Err?")
        ErrString = UPV.Read
        If Not ErrString.StartsWith("0") Then
            MessageBox.Show("UPV Error" & ControlChars.CrLf & ErrString, String.Empty, MessageBoxButtons.OK, MessageBoxIcon.Exclamation, MessageBoxDefaultButton.Button1, MessageBoxOptions.DefaultDesktopOnly)
            Me.Close()
        End If
        Debug.WriteLine("UPV Query = " & QueryString & "   Answer = " & AnswerString & "   Err = " & ErrString)
        Return AnswerString
    End Function

    Private Function Assemble(ByVal ValueArray() As Double, ByVal MaxInd As Integer) As String
        Dim Result As String = String.Empty
        Dim Index1 As Integer

        Try
            Result = ValueArray(0).ToString
            For Index1 = 1 To MaxInd
                If Index1 < ValueArray.Length Then
                    'Debug.WriteLine("ValueArray(" & Index1.ToString & " = " & ValueArray(Index1).ToString)
                    Result = Result & "," & ValueArray(Index1).ToString("0.#####")
                End If
            Next
            Return Result
        Catch ex As Exception
            Return String.Empty
        End Try

    End Function

    Private Sub CloseButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CloseButton.Click
        UPV.Close()                                                         'Release UPV connection
        Me.Close()
    End Sub

    Private Sub StartButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles StartButton.Click
        Dim Frequencies() As Double
        Dim Levels1() As Double
        Dim Levels2() As Double
        Dim Splitted() As String
        Dim Instring As String
        Dim Outstring As String
        Dim Index1 As Integer
        Dim Index2 As Integer
        Dim TwoChannels As Boolean
        Dim YUnit As String

        CloseButton.Enabled = False
        StartButton.Enabled = False

        '***** Configuration *****

        Instring = UPVQuery("DISPlay:BARGraph:A:UNIT:TRACk?")
        If Instring = "ON" Then
            YUnit = UPVQuery("SENSe:UNIT?")
        Else
            YUnit = UPVQuery("DISPlay:BARGraph:A:UNIT:USER?")
        End If
        Instring = UPVQuery("DISPlay:BARGraph:B:YSOurce?")
        TwoChannels = Not (Instring = "OFF")
        Instring = UPVQuery("TRAC:BAR:LOAD:AX?")
        Splitted = Instring.Split(","c)
        ReDim Frequencies(Splitted.Length - 1)
        For Index2 = 0 To Frequencies.Length - 1
            Frequencies(Index2) = Val(Splitted(Index2))
        Next
        ReDim Levels1(Splitted.Length - 1)
        For Index2 = 0 To Levels1.Length - 1
            Levels1(Index2) = 0
        Next
        If TwoChannels Then
            ReDim Levels2(Splitted.Length - 1)
            For Index2 = 0 To Levels2.Length - 1
                Levels2(Index2) = 0
            Next
        End If

        '***** Acquisition *****

        For Index1 = 1 To NumericUpDown1.Value
            TextBox1.Text = Index1.ToString
            Application.DoEvents()
            UPVCommand("INIT:CONT OFF; *WAI")
            Instring = UPVQuery("TRAC:BAR:LOAD:AY?")
            Splitted = Instring.Split(","c)
            For Index2 = 0 To Splitted.Length - 1
                Levels1(Index2) += Val(Splitted(Index2))
            Next
            If TwoChannels Then
                Instring = UPVQuery("TRAC:BAR:LOAD:BY?")
                Splitted = Instring.Split(","c)
                For Index2 = 0 To Splitted.Length - 1
                    Levels2(Index2) += Val(Splitted(Index2))
                Next
            End If
        Next

        '***** Write result spectrum back to sweep graph 1 *****

        For Index2 = 0 To Levels1.Length - 1
            Levels1(Index2) = Levels1(Index2) / NumericUpDown1.Value
        Next
        If TwoChannels Then
            For Index2 = 0 To Levels2.Length - 1
                Levels2(Index2) = Levels2(Index2) / NumericUpDown1.Value
            Next
        End If

        UPVCommand("DISP:SWE:X:SOUR MAN")
        UPVCommand("DISP:SWE:X:SCAL MAN")
        UPVCommand("DISPlay:SWEep:X:SPACing LOG")
        UPVCommand("DISPlay:SWEep:X:LEFT " & Frequencies(0).ToString("##.##") & " HZ")
        UPVCommand("DISPlay:SWEep:X:RIGHT " & Frequencies(Frequencies.Length - 1).ToString("##.##") & " HZ")
        If Not YUnit.StartsWith("'dB") Then
            Instring = UPVQuery("DISPlay:BARGraph:A:SPACing?")
            UPVCommand("DISPlay:SWEep:A:SPACing " & Instring)
        End If
        Instring = UPVQuery("DISPlay:BARGraph:A:TOP?")
        UPVCommand("DISPlay:SWEep:A:TOP " & Instring)
        Instring = UPVQuery("DISPlay:BARGraph:A:BOTTom?")
        UPVCommand("DISPlay:SWEep:A:BOTTom " & Instring)
        Outstring = Assemble(Frequencies, Frequencies.Length)
        UPVCommand("TRAC:SWE:STORE:AX " & Outstring)
        If TwoChannels Then
            UPVCommand("DISPlay:SWEep:TRACk:SCALing ON")
            UPVCommand("DISPlay:SWEep:B:YSOurce FUNC2")
            UPVCommand("TRAC:SWE:STORE:BX " & Outstring)
        Else
            UPVCommand("DISPlay:SWEep:B:YSOurce OFF")
        End If
        UPVCommand("DISPlay:SWEep:A:UNIT:AUTO OFF")
        UPVCommand("DISPlay:SWEep:A:UNIT:USER " & YUnit)                     'same unit as in bargraph
        Outstring = Assemble(Levels1, Levels1.Length)
        UPVCommand("TRAC:SWE:STORE:AY " & Outstring)
        If TwoChannels Then
            Outstring = Assemble(Levels2, Levels2.Length)
            UPVCommand("TRAC:SWE:STORE:BY " & Outstring)
        End If

        UPV.Write("*GTL")
        CloseButton.Enabled = True
        StartButton.Enabled = True

    End Sub
End Class
